diff --git a/lib/libcrypto/Makefile b/lib/libcrypto/Makefile
new file mode 100644
index 0000000000..0f2ab4bc96
--- /dev/null
+++ b/lib/libcrypto/Makefile
@@ -0,0 +1,1253 @@
+LIB=		private_crypto
+SHLIB_MAJOR=	47
+PRIVATELIB=	shpub
+SHLIBDIR?=	/lib
+INCSDIR=	${INCLUDEDIR}/priv/openssl
+
+WARNS?=		1
+
+OPENSSL_SRC=	${.CURDIR}/../../crypto/openssl
+
+# crypto
+.PATH:	${OPENSSL_SRC}/crypto
+SRCS=	\
+	asn1_dsa.c \
+	bsearch.c \
+	context.c \
+	core_algorithm.c \
+	core_fetch.c \
+	core_namemap.c \
+	cpt_err.c \
+	cpuid.c \
+	cryptlib.c \
+	ctype.c \
+	cversion.c \
+	der_writer.c \
+	ebcdic.c \
+	ex_data.c \
+	getenv.c \
+	info.c \
+	init.c \
+	initthread.c \
+	mem.c \
+	mem_sec.c \
+	o_dir.c \
+	o_fopen.c \
+	o_init.c \
+	o_str.c \
+	o_time.c \
+	packet.c \
+	param_build.c \
+	param_build_set.c \
+	params.c \
+	params_dup.c \
+	params_from_text.c \
+	passphrase.c \
+	provider.c \
+	provider_child.c \
+	provider_conf.c \
+	provider_core.c \
+	provider_predefined.c \
+	punycode.c \
+	self_test_core.c \
+	sparse_array.c \
+	threads_lib.c \
+	threads_pthread.c \
+	trace.c \
+	uid.c \
+	x86_64cpuid.s
+
+# crypto/aes
+.PATH:	${OPENSSL_SRC}/crypto/aes
+SRCS+=	\
+	aes_cfb.c \
+	aes_ecb.c \
+	aes_ige.c \
+	aes_misc.c \
+	aesni-mb-x86_64.s \
+	aesni-sha1-x86_64.s \
+	aesni-sha256-x86_64.s \
+	aesni-x86_64.s \
+	aes_ofb.c \
+	aes_wrap.c \
+	aes-x86_64.s \
+	bsaes-x86_64.s \
+	vpaes-x86_64.s
+
+# crypto/aria
+.PATH:	${OPENSSL_SRC}/crypto/aria
+SRCS+=	\
+	aria.c
+
+# crypto/asn1
+.PATH:	${OPENSSL_SRC}/crypto/asn1
+SRCS+=	\
+	a_bitstr.c \
+	a_d2i_fp.c \
+	a_digest.c \
+	a_dup.c \
+	a_gentm.c \
+	a_i2d_fp.c \
+	a_int.c \
+	a_mbstr.c \
+	ameth_lib.c \
+	a_object.c \
+	a_octet.c \
+	a_print.c \
+	a_sign.c \
+	asn1_err.c \
+	asn1_gen.c \
+	asn1_item_list.c \
+	asn1_lib.c \
+	asn1_parse.c \
+	asn_mime.c \
+	asn_moid.c \
+	asn_mstbl.c \
+	asn_pack.c \
+	a_strex.c \
+	a_strnid.c \
+	a_time.c \
+	a_type.c \
+	a_utctm.c \
+	a_utf8.c \
+	a_verify.c \
+	bio_asn1.c \
+	bio_ndef.c \
+	d2i_param.c \
+	d2i_pr.c \
+	d2i_pu.c \
+	evp_asn1.c \
+	f_int.c \
+	f_string.c \
+	i2d_evp.c \
+	n_pkey.c \
+	nsseq.c \
+	p5_pbe.c \
+	p5_pbev2.c \
+	p5_scrypt.c \
+	p8_pkey.c \
+	tasn_dec.c \
+	tasn_enc.c \
+	tasn_fre.c \
+	tasn_new.c \
+	tasn_prn.c \
+	tasn_scn.c \
+	tasn_typ.c \
+	tasn_utl.c \
+	t_bitst.c \
+	t_pkey.c \
+	t_spki.c \
+	x_algor.c \
+	x_bignum.c \
+	x_info.c \
+	x_int64.c \
+	x_long.c \
+	x_pkey.c \
+	x_sig.c \
+	x_spki.c \
+	x_val.c
+
+# crypto/async
+.PATH:	${OPENSSL_SRC}/crypto/async
+.PATH:	${OPENSSL_SRC}/crypto/async/arch
+SRCS+=	\
+	async.c \
+	async_err.c \
+	async_null.c \
+	async_posix.c \
+	async_wait.c \
+	async_win.c
+
+# crypto/bf
+.PATH:	${OPENSSL_SRC}/crypto/bf
+SRCS+=	\
+	bf_cfb64.c \
+	bf_ecb.c \
+	bf_enc.c \
+	bf_ofb64.c \
+	bf_skey.c
+
+# crypto/bio
+.PATH:	${OPENSSL_SRC}/crypto/bio
+SRCS+=	\
+	bf_buff.c \
+	bf_lbuf.c \
+	bf_nbio.c \
+	bf_null.c \
+	bf_prefix.c \
+	bf_readbuff.c \
+	bio_addr.c \
+	bio_cb.c \
+	bio_dump.c \
+	bio_err.c \
+	bio_lib.c \
+	bio_meth.c \
+	bio_print.c \
+	bio_sock2.c \
+	bio_sock.c \
+	bss_acpt.c \
+	bss_bio.c \
+	bss_conn.c \
+	bss_core.c \
+	bss_dgram.c \
+	bss_fd.c \
+	bss_file.c \
+	bss_log.c \
+	bss_mem.c \
+	bss_null.c \
+	bss_sock.c \
+	ossl_core_bio.c
+
+# crypto/bn
+.PATH:	${OPENSSL_SRC}/crypto/bn
+.PATH:	${OPENSSL_SRC}/crypto/bn/asm
+SRCS+=	\
+	bn_add.c \
+	bn_blind.c \
+	bn_const.c \
+	bn_conv.c \
+	bn_ctx.c \
+	bn_depr.c \
+	bn_dh.c \
+	bn_div.c \
+	bn_err.c \
+	bn_exp2.c \
+	bn_exp.c \
+	bn_gcd.c \
+	bn_gf2m.c \
+	bn_intern.c \
+	bn_kron.c \
+	bn_lib.c \
+	bn_mod.c \
+	bn_mont.c \
+	bn_mpi.c \
+	bn_mul.c \
+	bn_nist.c \
+	bn_prime.c \
+	bn_print.c \
+	bn_rand.c \
+	bn_recp.c \
+	bn_rsa_fips186_4.c \
+	bn_shift.c \
+	bn_sqr.c \
+	bn_sqrt.c \
+	bn_srp.c \
+	bn_word.c \
+	bn_x931p.c \
+	rsaz-avx2.s \
+	rsaz-avx512.s \
+	rsaz_exp.c \
+	rsaz_exp_x2.c \
+	rsaz-x86_64.s \
+	x86_64-gcc.c \
+	x86_64-gf2m.s \
+	x86_64-mont5.s \
+	x86_64-mont.s
+
+# crypto/buffer
+.PATH:	${OPENSSL_SRC}/crypto/buffer
+SRCS+=	\
+	buf_err.c \
+	buffer.c
+
+# crypto/camellia
+.PATH:	${OPENSSL_SRC}/crypto/camellia
+SRCS+=	\
+	cmll_cfb.c \
+	cmll_ctr.c \
+	cmll_ecb.c \
+	cmll_misc.c \
+	cmll_ofb.c \
+	cmll-x86_64.s
+
+# crypto/cast
+.PATH:	${OPENSSL_SRC}/crypto/cast
+SRCS+=	\
+	c_cfb64.c \
+	c_ecb.c \
+	c_enc.c \
+	c_ofb64.c \
+	c_skey.c
+
+# crypto/chacha
+.PATH:	${OPENSSL_SRC}/crypto/chacha
+SRCS+=	\
+	chacha-x86_64.s
+
+# crypto/cmac
+.PATH:	${OPENSSL_SRC}/crypto/cmac
+SRCS+=	\
+	cmac.c
+
+# crypto/cmp
+.PATH:	${OPENSSL_SRC}/crypto/cmp
+SRCS+=	\
+	cmp_asn.c \
+	cmp_client.c \
+	cmp_ctx.c \
+	cmp_err.c \
+	cmp_hdr.c \
+	cmp_http.c \
+	cmp_msg.c \
+	cmp_protect.c \
+	cmp_server.c \
+	cmp_status.c \
+	cmp_util.c \
+	cmp_vfy.c
+
+# crypto/cms
+.PATH:	${OPENSSL_SRC}/crypto/cms
+SRCS+=	\
+	cms_asn1.c \
+	cms_att.c \
+	cms_cd.c \
+	cms_dd.c \
+	cms_dh.c \
+	cms_ec.c \
+	cms_enc.c \
+	cms_env.c \
+	cms_err.c \
+	cms_ess.c \
+	cms_io.c \
+	cms_kari.c \
+	cms_lib.c \
+	cms_pwri.c \
+	cms_rsa.c \
+	cms_sd.c \
+	cms_smime.c
+
+# crypto/comp
+.PATH:	${OPENSSL_SRC}/crypto/comp
+SRCS+=	\
+	comp_err.c \
+	comp_lib.c \
+	c_zlib.c
+
+# crypto/conf
+.PATH:	${OPENSSL_SRC}/crypto/conf
+SRCS+=	\
+	conf_api.c \
+	conf_def.c \
+	conf_err.c \
+	conf_lib.c \
+	conf_mall.c \
+	conf_mod.c \
+	conf_sap.c \
+	conf_ssl.c
+
+# crypto/crmf
+.PATH:	${OPENSSL_SRC}/crypto/crmf
+SRCS+=	\
+	crmf_asn.c \
+	crmf_err.c \
+	crmf_lib.c \
+	crmf_pbm.c
+
+# crypto/ct
+.PATH:	${OPENSSL_SRC}/crypto/ct
+SRCS+=	\
+	ct_b64.c \
+	ct_err.c \
+	ct_log.c \
+	ct_oct.c \
+	ct_policy.c \
+	ct_prn.c \
+	ct_sct.c \
+	ct_sct_ctx.c \
+	ct_vfy.c \
+	ct_x509v3.c
+
+# crypto/des
+.PATH:	${OPENSSL_SRC}/crypto/des
+SRCS+=	\
+	cbc_cksm.c \
+	cbc_enc.c \
+	cfb64ede.c \
+	cfb64enc.c \
+	cfb_enc.c \
+	des_enc.c \
+	ecb3_enc.c \
+	ecb_enc.c \
+	fcrypt_b.c \
+	fcrypt.c \
+	ofb64ede.c \
+	ofb64enc.c \
+	ofb_enc.c \
+	pcbc_enc.c \
+	qud_cksm.c \
+	rand_key.c \
+	set_key.c \
+	str2key.c \
+	xcbc_enc.c
+
+# crypto/dh
+.PATH:	${OPENSSL_SRC}/crypto/dh
+SRCS+=	\
+	dh_ameth.c \
+	dh_asn1.c \
+	dh_backend.c \
+	dh_check.c \
+	dh_depr.c \
+	dh_err.c \
+	dh_gen.c \
+	dh_group_params.c \
+	dh_kdf.c \
+	dh_key.c \
+	dh_lib.c \
+	dh_meth.c \
+	dh_pmeth.c \
+	dh_prn.c \
+	dh_rfc5114.c
+
+# crypto/dsa
+.PATH:	${OPENSSL_SRC}/crypto/dsa
+SRCS+=	\
+	dsa_ameth.c \
+	dsa_asn1.c \
+	dsa_backend.c \
+	dsa_check.c \
+	dsa_depr.c \
+	dsa_err.c \
+	dsa_gen.c \
+	dsa_key.c \
+	dsa_lib.c \
+	dsa_meth.c \
+	dsa_ossl.c \
+	dsa_pmeth.c \
+	dsa_prn.c \
+	dsa_sign.c \
+	dsa_vrf.c
+
+# crypto/dso
+.PATH:	${OPENSSL_SRC}/crypto/dso
+SRCS+=	\
+	dso_dl.c \
+	dso_dlfcn.c \
+	dso_err.c \
+	dso_lib.c \
+	dso_openssl.c \
+	dso_vms.c \
+	dso_win32.c
+
+# crypto/ec
+.PATH:	${OPENSSL_SRC}/crypto/ec
+.PATH:	${OPENSSL_SRC}/crypto/ec/curve448
+.PATH:	${OPENSSL_SRC}/crypto/ec/curve448/arch_32
+.PATH:	${OPENSSL_SRC}/crypto/ec/curve448/arch_64
+SRCS+=	\
+	curve25519.c \
+	curve448.c \
+	curve448_tables.c \
+	ec2_oct.c \
+	ec2_smpl.c \
+	ec_ameth.c \
+	ec_asn1.c \
+	ec_backend.c \
+	ec_check.c \
+	ec_curve.c \
+	ec_cvt.c \
+	ec_deprecated.c \
+	ecdh_kdf.c \
+	ecdh_ossl.c \
+	ecdsa_ossl.c \
+	ecdsa_sign.c \
+	ecdsa_vrf.c \
+	ec_err.c \
+	ec_key.c \
+	ec_kmeth.c \
+	eck_prn.c \
+	ec_lib.c \
+	ec_mult.c \
+	ec_oct.c \
+	ec_pmeth.c \
+	ecp_mont.c \
+	ecp_nist.c \
+	ecp_nistz256.c \
+	ecp_nistz256-x86_64.s \
+	ecp_oct.c \
+	ec_print.c \
+	ecp_smpl.c \
+	ecx_backend.c \
+	ecx_key.c \
+	ecx_meth.c \
+	eddsa.c \
+	f_generic.c \
+	f_impl32.c \
+	f_impl64.c \
+	scalar.c \
+	x25519-x86_64.s
+
+# crypto/encode_decode
+.PATH:	${OPENSSL_SRC}/crypto/encode_decode
+SRCS+=	\
+	decoder_err.c \
+	decoder_lib.c \
+	decoder_meth.c \
+	decoder_pkey.c \
+	encoder_err.c \
+	encoder_lib.c \
+	encoder_meth.c \
+	encoder_pkey.c
+
+# crypto/engine
+.PATH:	${OPENSSL_SRC}/crypto/engine
+SRCS+=	\
+	eng_all.c \
+	eng_cnf.c \
+	eng_ctrl.c \
+	eng_dyn.c \
+	eng_err.c \
+	eng_fat.c \
+	eng_init.c \
+	eng_lib.c \
+	eng_list.c \
+	eng_openssl.c \
+	eng_pkey.c \
+	eng_rdrand.c \
+	eng_table.c \
+	tb_asnmth.c \
+	tb_cipher.c \
+	tb_dh.c \
+	tb_digest.c \
+	tb_dsa.c \
+	tb_eckey.c \
+	tb_pkmeth.c \
+	tb_rand.c \
+	tb_rsa.c
+
+# crypto/err
+.PATH:	${OPENSSL_SRC}/crypto/err
+SRCS+=	\
+	err_all.c \
+	err_all_legacy.c \
+	err_blocks.c \
+	err.c \
+	err_prn.c
+
+# crypto/ess
+.PATH:	${OPENSSL_SRC}/crypto/ess
+SRCS+=	\
+	ess_asn1.c \
+	ess_err.c \
+	ess_lib.c
+
+# crypto/evp
+.PATH:	${OPENSSL_SRC}/crypto/evp
+SRCS+=	\
+	asymcipher.c \
+	bio_b64.c \
+	bio_enc.c \
+	bio_md.c \
+	bio_ok.c \
+	c_allc.c \
+	c_alld.c \
+	cmeth_lib.c \
+	ctrl_params_translate.c \
+	dh_ctrl.c \
+	dh_support.c \
+	digest.c \
+	dsa_ctrl.c \
+	e_aes.c \
+	e_aes_cbc_hmac_sha1.c \
+	e_aes_cbc_hmac_sha256.c \
+	e_aria.c \
+	e_bf.c \
+	e_camellia.c \
+	e_cast.c \
+	ec_ctrl.c \
+	e_chacha20_poly1305.c \
+	ec_support.c \
+	e_des3.c \
+	e_des.c \
+	e_idea.c \
+	encode.c \
+	e_null.c \
+	e_old.c \
+	e_rc2.c \
+	e_rc4.c \
+	e_rc4_hmac_md5.c \
+	e_rc5.c \
+	e_seed.c \
+	e_sm4.c \
+	evp_cnf.c \
+	evp_enc.c \
+	evp_err.c \
+	evp_fetch.c \
+	evp_key.c \
+	evp_lib.c \
+	evp_pbe.c \
+	evp_pkey.c \
+	evp_rand.c \
+	evp_utils.c \
+	e_xcbc_d.c \
+	exchange.c \
+	kdf_lib.c \
+	kdf_meth.c \
+	kem.c \
+	keymgmt_lib.c \
+	keymgmt_meth.c \
+	legacy_blake2.c \
+	legacy_md4.c \
+	legacy_md5.c \
+	legacy_md5_sha1.c \
+	legacy_mdc2.c \
+	legacy_ripemd.c \
+	legacy_sha.c \
+	legacy_wp.c \
+	mac_lib.c \
+	mac_meth.c \
+	m_null.c \
+	m_sigver.c \
+	names.c \
+	p5_crpt2.c \
+	p5_crpt.c \
+	pbe_scrypt.c \
+	p_dec.c \
+	p_enc.c \
+	p_legacy.c \
+	p_lib.c \
+	pmeth_check.c \
+	pmeth_gn.c \
+	pmeth_lib.c \
+	p_open.c \
+	p_seal.c \
+	p_sign.c \
+	p_verify.c \
+	signature.c
+
+# crypto/ffc
+.PATH:	${OPENSSL_SRC}/crypto/ffc
+SRCS+=	\
+	ffc_backend.c \
+	ffc_dh.c \
+	ffc_key_generate.c \
+	ffc_key_validate.c \
+	ffc_params.c \
+	ffc_params_generate.c \
+	ffc_params_validate.c
+
+# crypto/hmac
+.PATH:	${OPENSSL_SRC}/crypto/hmac
+SRCS+=	\
+	hmac.c
+
+# crypto/http
+.PATH:	${OPENSSL_SRC}/crypto/http
+SRCS+=	\
+	http_client.c \
+	http_err.c \
+	http_lib.c
+
+# crypto/idea
+.PATH:	${OPENSSL_SRC}/crypto/idea
+SRCS+=	\
+	i_cbc.c \
+	i_cfb64.c \
+	i_ecb.c \
+	i_ofb64.c \
+	i_skey.c
+
+# crypto/kdf
+.PATH:	${OPENSSL_SRC}/crypto/kdf
+SRCS+=	\
+	kdf_err.c
+
+# crypto/lhash
+.PATH:	${OPENSSL_SRC}/crypto/lhash
+SRCS+=	\
+	lhash.c \
+	lh_stats.c
+
+# crypto/md4
+.PATH:	${OPENSSL_SRC}/crypto/md4
+SRCS+=	\
+	md4_dgst.c \
+	md4_one.c
+
+# crypto/md5
+.PATH:	${OPENSSL_SRC}/crypto/md5
+SRCS+=	\
+	md5_dgst.c \
+	md5_one.c \
+	md5_sha1.c \
+	md5-x86_64.s
+
+# crypto/mdc2
+.PATH:	${OPENSSL_SRC}/crypto/mdc2
+SRCS+=	\
+	mdc2dgst.c \
+	mdc2_one.c
+
+# crypto/modes
+.PATH:	${OPENSSL_SRC}/crypto/modes
+SRCS+=	\
+	aesni-gcm-x86_64.s \
+	cbc128.c \
+	ccm128.c \
+	cfb128.c \
+	ctr128.c \
+	cts128.c \
+	gcm128.c \
+	ghash-x86_64.s \
+	ocb128.c \
+	ofb128.c \
+	siv128.c \
+	wrap128.c \
+	xts128.c
+
+# crypto/objects
+.PATH:	${OPENSSL_SRC}/crypto/objects
+SRCS+=	\
+	obj_dat.c \
+	obj_err.c \
+	obj_lib.c \
+	obj_xref.c \
+	o_names.c
+
+# crypto/ocsp
+.PATH:	${OPENSSL_SRC}/crypto/ocsp
+SRCS+=	\
+	ocsp_asn.c \
+	ocsp_cl.c \
+	ocsp_err.c \
+	ocsp_ext.c \
+	ocsp_http.c \
+	ocsp_lib.c \
+	ocsp_prn.c \
+	ocsp_srv.c \
+	ocsp_vfy.c \
+	v3_ocsp.c
+
+# crypto/pem
+.PATH:	${OPENSSL_SRC}/crypto/pem
+SRCS+=	\
+	pem_all.c \
+	pem_err.c \
+	pem_info.c \
+	pem_lib.c \
+	pem_oth.c \
+	pem_pk8.c \
+	pem_pkey.c \
+	pem_sign.c \
+	pem_x509.c \
+	pem_xaux.c \
+	pvkfmt.c
+
+# crypto/pkcs12
+.PATH:	${OPENSSL_SRC}/crypto/pkcs12
+SRCS+=	\
+	p12_add.c \
+	p12_asn.c \
+	p12_attr.c \
+	p12_crpt.c \
+	p12_crt.c \
+	p12_decr.c \
+	p12_init.c \
+	p12_key.c \
+	p12_kiss.c \
+	p12_mutl.c \
+	p12_npas.c \
+	p12_p8d.c \
+	p12_p8e.c \
+	p12_sbag.c \
+	p12_utl.c \
+	pk12err.c
+
+# crypto/pkcs7
+.PATH:	${OPENSSL_SRC}/crypto/pkcs7
+SRCS+=	\
+	bio_pk7.c \
+	pk7_asn1.c \
+	pk7_attr.c \
+	pk7_doit.c \
+	pk7_lib.c \
+	pk7_mime.c \
+	pk7_smime.c \
+	pkcs7err.c
+
+# crypto/poly1305
+.PATH:	${OPENSSL_SRC}/crypto/poly1305
+SRCS+=	\
+	poly1305.c \
+	poly1305-x86_64.s
+
+# crypto/property
+.PATH:	${OPENSSL_SRC}/crypto/property
+SRCS+=	\
+	defn_cache.c \
+	property.c \
+	property_err.c \
+	property_parse.c \
+	property_query.c \
+	property_string.c
+
+# crypto/rand
+.PATH:	${OPENSSL_SRC}/crypto/rand
+SRCS+=	\
+	prov_seed.c \
+	rand_deprecated.c \
+	rand_err.c \
+	randfile.c \
+	rand_lib.c \
+	rand_meth.c \
+	rand_pool.c
+
+# crypto/rc2
+.PATH:	${OPENSSL_SRC}/crypto/rc2
+SRCS+=	\
+	rc2_cbc.c \
+	rc2cfb64.c \
+	rc2_ecb.c \
+	rc2ofb64.c \
+	rc2_skey.c
+
+# crypto/rc4
+.PATH:	${OPENSSL_SRC}/crypto/rc4
+SRCS+=	\
+	rc4-md5-x86_64.s \
+	rc4-x86_64.s
+
+# crypto/ripemd
+.PATH:	${OPENSSL_SRC}/crypto/ripemd
+SRCS+=	\
+	rmd_dgst.c \
+	rmd_one.c
+
+# crypto/rsa
+.PATH:	${OPENSSL_SRC}/crypto/rsa
+SRCS+=	\
+	rsa_ameth.c \
+	rsa_asn1.c \
+	rsa_backend.c \
+	rsa_chk.c \
+	rsa_crpt.c \
+	rsa_depr.c \
+	rsa_err.c \
+	rsa_gen.c \
+	rsa_lib.c \
+	rsa_meth.c \
+	rsa_mp.c \
+	rsa_mp_names.c \
+	rsa_none.c \
+	rsa_oaep.c \
+	rsa_ossl.c \
+	rsa_pk1.c \
+	rsa_pmeth.c \
+	rsa_prn.c \
+	rsa_pss.c \
+	rsa_saos.c \
+	rsa_schemes.c \
+	rsa_sign.c \
+	rsa_sp800_56b_check.c \
+	rsa_sp800_56b_gen.c \
+	rsa_x931.c \
+	rsa_x931g.c
+
+# crypto/seed
+.PATH:	${OPENSSL_SRC}/crypto/seed
+SRCS+=	\
+	seed.c \
+	seed_cbc.c \
+	seed_cfb.c \
+	seed_ecb.c \
+	seed_ofb.c
+
+# crypto/sha
+.PATH:	${OPENSSL_SRC}/crypto/sha
+SRCS+=	\
+	keccak1600-x86_64.s \
+	sha1dgst.c \
+	sha1-mb-x86_64.s \
+	sha1_one.c \
+	sha1-x86_64.s \
+	sha256.c \
+	sha256-mb-x86_64.s \
+	sha256-x86_64.s \
+	sha3.c \
+	sha512.c \
+	sha512-x86_64.s
+
+# crypto/siphash
+.PATH:	${OPENSSL_SRC}/crypto/siphash
+SRCS+=	\
+	siphash.c
+
+# crypto/sm2
+.PATH:	${OPENSSL_SRC}/crypto/sm2
+SRCS+=	\
+	sm2_crypt.c \
+	sm2_err.c \
+	sm2_key.c \
+	sm2_sign.c
+
+# crypto/sm3
+.PATH:	${OPENSSL_SRC}/crypto/sm3
+SRCS+=	\
+	legacy_sm3.c \
+	sm3.c
+
+# crypto/sm4
+.PATH:	${OPENSSL_SRC}/crypto/sm4
+SRCS+=	\
+	sm4.c
+
+# crypto/srp
+.PATH:	${OPENSSL_SRC}/crypto/srp
+SRCS+=	\
+	srp_lib.c \
+	srp_vfy.c
+
+# crypto/stack
+.PATH:	${OPENSSL_SRC}/crypto/stack
+SRCS+=	\
+	stack.c
+
+# crypto/store
+.PATH:	${OPENSSL_SRC}/crypto/store
+SRCS+=	\
+	store_err.c \
+	store_init.c \
+	store_lib.c \
+	store_meth.c \
+	store_register.c \
+	store_result.c \
+	store_strings.c
+
+# crypto/ts
+.PATH:	${OPENSSL_SRC}/crypto/ts
+SRCS+=	\
+	ts_asn1.c \
+	ts_conf.c \
+	ts_err.c \
+	ts_lib.c \
+	ts_req_print.c \
+	ts_req_utils.c \
+	ts_rsp_print.c \
+	ts_rsp_sign.c \
+	ts_rsp_utils.c \
+	ts_rsp_verify.c \
+	ts_verify_ctx.c
+
+# crypto/txt_db
+.PATH:	${OPENSSL_SRC}/crypto/txt_db
+SRCS+=	\
+	txt_db.c
+
+# crypto/ui
+.PATH:	${OPENSSL_SRC}/crypto/ui
+SRCS+=	\
+	ui_err.c \
+	ui_lib.c \
+	ui_null.c \
+	ui_openssl.c \
+	ui_util.c
+
+# crypto/whrlpool
+.PATH:	${OPENSSL_SRC}/crypto/whrlpool
+SRCS+=	\
+	wp_dgst.c \
+	wp-x86_64.s
+
+# crypto/x509
+.PATH:	${OPENSSL_SRC}/crypto/x509
+SRCS+=	\
+	by_dir.c \
+	by_file.c \
+	by_store.c \
+	pcy_cache.c \
+	pcy_data.c \
+	pcy_lib.c \
+	pcy_map.c \
+	pcy_node.c \
+	pcy_tree.c \
+	t_crl.c \
+	t_req.c \
+	t_x509.c \
+	v3_addr.c \
+	v3_admis.c \
+	v3_akeya.c \
+	v3_akid.c \
+	v3_asid.c \
+	v3_bcons.c \
+	v3_bitst.c \
+	v3_conf.c \
+	v3_cpols.c \
+	v3_crld.c \
+	v3_enum.c \
+	v3err.c \
+	v3_extku.c \
+	v3_genn.c \
+	v3_ia5.c \
+	v3_info.c \
+	v3_int.c \
+	v3_ist.c \
+	v3_lib.c \
+	v3_ncons.c \
+	v3_pcia.c \
+	v3_pci.c \
+	v3_pcons.c \
+	v3_pku.c \
+	v3_pmaps.c \
+	v3_prn.c \
+	v3_purp.c \
+	v3_san.c \
+	v3_skid.c \
+	v3_sxnet.c \
+	v3_tlsf.c \
+	v3_utf8.c \
+	v3_utl.c \
+	x509_att.c \
+	x509_cmp.c \
+	x509cset.c \
+	x509_d2.c \
+	x509_def.c \
+	x509_err.c \
+	x509_ext.c \
+	x509_lu.c \
+	x509_meth.c \
+	x509name.c \
+	x509_obj.c \
+	x509_r2x.c \
+	x509_req.c \
+	x509rset.c \
+	x509_set.c \
+	x509spki.c \
+	x509_trust.c \
+	x509_txt.c \
+	x509type.c \
+	x509_v3.c \
+	x509_vfy.c \
+	x509_vpm.c \
+	x_all.c \
+	x_attrib.c \
+	x_crl.c \
+	x_exten.c \
+	x_name.c \
+	x_pubkey.c \
+	x_req.c \
+	x_x509a.c \
+	x_x509.c
+
+# providers
+.PATH:	${OPENSSL_SRC}/providers
+SRCS+=	\
+	baseprov.c \
+	defltprov.c \
+	nullprov.c \
+	prov_running.c
+
+# providers/common
+.PATH:	${OPENSSL_SRC}/providers/common
+.PATH:	${OPENSSL_SRC}/providers/common/der
+SRCS+=	\
+	bio_prov.c \
+	capabilities.c \
+	der_digests_gen.c \
+	der_dsa_gen.c \
+	der_dsa_key.c \
+	der_dsa_sig.c \
+	der_ec_gen.c \
+	der_ec_key.c \
+	der_ec_sig.c \
+	der_ecx_gen.c \
+	der_ecx_key.c \
+	der_rsa_gen.c \
+	der_rsa_key.c \
+	der_rsa_sig.c \
+	der_sm2_gen.c \
+	der_sm2_key.c \
+	der_sm2_sig.c \
+	der_wrap_gen.c \
+	digest_to_nid.c \
+	provider_ctx.c \
+	provider_err.c \
+	provider_seeding.c \
+	provider_util.c \
+	securitycheck.c \
+	securitycheck_default.c
+
+# providers/implementations
+.PATH:	${OPENSSL_SRC}/providers/implementations/asymciphers
+.PATH:	${OPENSSL_SRC}/providers/implementations/ciphers
+.PATH:	${OPENSSL_SRC}/providers/implementations/digests
+.PATH:	${OPENSSL_SRC}/providers/implementations/encode_decode
+.PATH:	${OPENSSL_SRC}/providers/implementations/exchange
+.PATH:	${OPENSSL_SRC}/providers/implementations/kdfs
+.PATH:	${OPENSSL_SRC}/providers/implementations/kem
+.PATH:	${OPENSSL_SRC}/providers/implementations/keymgmt
+.PATH:	${OPENSSL_SRC}/providers/implementations/macs
+.PATH:	${OPENSSL_SRC}/providers/implementations/rands
+.PATH:	${OPENSSL_SRC}/providers/implementations/rands/seeding
+.PATH:	${OPENSSL_SRC}/providers/implementations/signature
+.PATH:	${OPENSSL_SRC}/providers/implementations/storemgmt
+SRCS+=	\
+	blake2b_mac.c \
+	blake2b_prov.c \
+	blake2_prov.c \
+	blake2s_mac.c \
+	blake2s_prov.c \
+	cipher_aes.c \
+	cipher_aes_cbc_hmac_sha1_hw.c \
+	cipher_aes_cbc_hmac_sha256_hw.c \
+	cipher_aes_cbc_hmac_sha.c \
+	cipher_aes_ccm.c \
+	cipher_aes_ccm_hw.c \
+	cipher_aes_gcm.c \
+	cipher_aes_gcm_hw.c \
+	cipher_aes_hw.c \
+	cipher_aes_ocb.c \
+	cipher_aes_ocb_hw.c \
+	cipher_aes_siv.c \
+	cipher_aes_siv_hw.c \
+	cipher_aes_wrp.c \
+	cipher_aes_xts.c \
+	cipher_aes_xts_fips.c \
+	cipher_aes_xts_hw.c \
+	cipher_aria.c \
+	cipher_aria_ccm.c \
+	cipher_aria_ccm_hw.c \
+	cipher_aria_gcm.c \
+	cipher_aria_gcm_hw.c \
+	cipher_aria_hw.c \
+	cipher_camellia.c \
+	cipher_camellia_hw.c \
+	cipher_chacha20.c \
+	cipher_chacha20_hw.c \
+	cipher_chacha20_poly1305.c \
+	cipher_chacha20_poly1305_hw.c \
+	ciphercommon_block.c \
+	ciphercommon.c \
+	ciphercommon_ccm.c \
+	ciphercommon_ccm_hw.c \
+	ciphercommon_gcm.c \
+	ciphercommon_gcm_hw.c \
+	ciphercommon_hw.c \
+	cipher_cts.c \
+	cipher_null.c \
+	cipher_sm4.c \
+	cipher_sm4_hw.c \
+	cipher_tdes.c \
+	cipher_tdes_common.c \
+	cipher_tdes_default.c \
+	cipher_tdes_default_hw.c \
+	cipher_tdes_hw.c \
+	cipher_tdes_wrap.c \
+	cipher_tdes_wrap_hw.c \
+	cmac_prov.c \
+	crngt.c \
+	decode_der2key.c \
+	decode_epki2pki.c \
+	decode_msblob2key.c \
+	decode_pem2der.c \
+	decode_pvk2key.c \
+	decode_spki2typespki.c \
+	dh_exch.c \
+	dh_kmgmt.c \
+	digestcommon.c \
+	drbg.c \
+	drbg_ctr.c \
+	drbg_hash.c \
+	drbg_hmac.c \
+	dsa_kmgmt.c \
+	dsa_sig.c \
+	ecdh_exch.c \
+	ecdsa_sig.c \
+	ec_kmgmt.c \
+	ecx_exch.c \
+	ecx_kmgmt.c \
+	eddsa_sig.c \
+	encode_key2any.c \
+	encode_key2blob.c \
+	encode_key2ms.c \
+	encode_key2text.c \
+	endecoder_common.c \
+	file_store_any2obj.c \
+	file_store.c \
+	gmac_prov.c \
+	hkdf.c \
+	hmac_prov.c \
+	kbkdf.c \
+	kdf_exch.c \
+	kdf_legacy_kmgmt.c \
+	kmac_prov.c \
+	krb5kdf.c \
+	mac_legacy_kmgmt.c \
+	mac_legacy_sig.c \
+	md5_prov.c \
+	md5_sha1_prov.c \
+	pbkdf2.c \
+	pbkdf2_fips.c \
+	pkcs12kdf.c \
+	poly1305_prov.c \
+	rand_cpu_x86.c \
+	rand_tsc.c \
+	rand_unix.c \
+	rand_win.c \
+	rsa_enc.c \
+	rsa_kem.c \
+	rsa_kmgmt.c \
+	rsa_sig.c \
+	scrypt.c \
+	seed_src.c \
+	sha2_prov.c \
+	sha3_prov.c \
+	siphash_prov.c \
+	sm2_enc.c \
+	sm2_sig.c \
+	sm3_prov.c \
+	sshkdf.c \
+	sskdf.c \
+	test_rng.c \
+	tls1_prf.c \
+	x942kdf.c
+
+# ssl
+.PATH:	${OPENSSL_SRC}/ssl
+SRCS+=	\
+	s3_cbc.c
+
+# ssl/record
+.PATH:	${OPENSSL_SRC}/ssl/record
+SRCS+=	\
+	tls_pad.c
+
+.PATH:	${OPENSSL_SRC}/include/openssl
+INCS=	asn1.h asn1err.h async.h asyncerr.h bio.h bioerr.h bn.h bnerr.h buffer.h buffererr.h comp.h comperr.h conf.h conferr.h configuration.h conftypes.h core.h core_dispatch.h crypto.h cryptoerr.h cryptoerr_legacy.h ct.h cterr.h des.h dh.h dherr.h dsa.h dsaerr.h ebcdic.h ec.h ecerr.h e_os2.h err.h evp.h evperr.h hmac.h http.h lhash.h macros.h md4.h md5.h \
+	objects.h objectserr.h obj_mac.h opensslconf.h opensslv.h ocsp.h ocsperr.h ossl_typ.h params.h pem.h pemerr.h pkcs7.h pkcs7err.h rc4.h ripemd.h rsa.h rsaerr.h safestack.h sha.h stack.h symhacks.h types.h x509.h x509err.h x509v3.h x509v3err.h x509_vfy.h
+
+CFLAGS+=-DAES_ASM \
+	-DBSAES_ASM \
+	-DCMLL_ASM \
+	-DECP_NISTZ256_ASM \
+	-DGHASH_ASM \
+	-DKECCAK1600_ASM \
+	-DMD5_ASM \
+	-DOPENSSL_BN_ASM_GF2m \
+	-DOPENSSL_BN_ASM_MONT \
+	-DOPENSSL_BN_ASM_MONT5 \
+	-DOPENSSL_CPUID_OBJ \
+	-DOPENSSL_IA32_SSE2 \
+	-DPOLY1305_ASM \
+	-DSHA1_ASM \
+	-DSHA256_ASM \
+	-DSHA512_ASM \
+	-DVPAES_ASM \
+	-DWHIRLPOOL_ASM \
+	-DX25519_ASM \
+	-Wa,--noexecstack \
+	-DL_ENDIAN \
+	${PRIVATELIB_CFLAGS} \
+	-I${OPENSSL_SRC} \
+	-I${OPENSSL_SRC}/include \
+	-I${OPENSSL_SRC}/providers/common/include \
+	-I${OPENSSL_SRC}/providers/implementations/include \
+	-DOPENSSLDIR="\"/etc/ssl\"" \
+	-DENGINESDIR="\"${LIBDIR}/engines\"" \
+	-DMODULESDIR="\"${LIBDIR}/ossl-modules\""
+
+DPADD=	${LIBPTHREAD}
+LDADD=	-lpthread
+
+SUBDIR=	engines
+
+.include <bsd.lib.mk>
diff --git a/lib/libcrypto/engines/Makefile b/lib/libcrypto/engines/Makefile
new file mode 100644
index 0000000000..fbb72af055
--- /dev/null
+++ b/lib/libcrypto/engines/Makefile
@@ -0,0 +1,8 @@
+# $FreeBSD$
+
+SUBDIR=		capi
+.if ${MACHINE_ARCH} == "x86_64"
+SUBDIR+=	padlock
+.endif
+
+.include <bsd.subdir.mk>
diff --git a/lib/libcrypto/engines/Makefile.inc b/lib/libcrypto/engines/Makefile.inc
new file mode 100644
index 0000000000..216c529b3f
--- /dev/null
+++ b/lib/libcrypto/engines/Makefile.inc
@@ -0,0 +1,14 @@
+# $FreeBSD$
+
+SHLIBDIR=	${LIBDIR}/engines
+
+OPENSSL_SRC=	${.CURDIR}/../../../../crypto/openssl
+
+CFLAGS+=	-I${OPENSSL_SRC}/engines
+CFLAGS+=	-I${OPENSSL_SRC}/include
+CFLAGS+=	-DL_ENDIAN
+CFLAGS+=	-DNDEBUG
+
+.PATH: ${OPENSSL_SRC}/engines
+
+WARNS?=		0
diff --git a/lib/libcrypto/engines/capi/Makefile b/lib/libcrypto/engines/capi/Makefile
new file mode 100644
index 0000000000..85b509e7b6
--- /dev/null
+++ b/lib/libcrypto/engines/capi/Makefile
@@ -0,0 +1,7 @@
+# $FreeBSD$
+
+SHLIB_NAME?=	capi.so
+
+SRCS=	e_capi.c
+
+.include <bsd.lib.mk>
diff --git a/lib/libcrypto/engines/padlock/Makefile b/lib/libcrypto/engines/padlock/Makefile
new file mode 100644
index 0000000000..9d0462115b
--- /dev/null
+++ b/lib/libcrypto/engines/padlock/Makefile
@@ -0,0 +1,10 @@
+# $FreeBSD$
+
+SHLIB_NAME?=	padlock.so
+
+SRCS=	e_padlock.c
+.if ${MACHINE_ARCH} == "x86_64"
+SRCS+=	e_padlock-x86_64.s
+.endif
+
+.include <bsd.lib.mk>
diff --git a/lib/libdmsg/Makefile b/lib/libdmsg/Makefile
index 6c2a2352d6..f61449d9eb 100644
--- a/lib/libdmsg/Makefile
+++ b/lib/libdmsg/Makefile
@@ -4,7 +4,8 @@ LIB=	dmsg
 SRCS+=	debug.c subs.c crypto.c msg.c msg_lnk.c service.c
 
 CFLAGS+=	-pthread
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 INCS=	dmsg.h
 
diff --git a/lib/libdmsg/crypto.c b/lib/libdmsg/crypto.c
index 15a1906e22..d5f9af93dc 100644
--- a/lib/libdmsg/crypto.c
+++ b/lib/libdmsg/crypto.c
@@ -62,6 +62,7 @@ static struct crypto_algo crypto_algos[] = {
 	{ NULL, 0, 0, NULL, NULL, NULL }
 };
 
+#if 0
 static
 unsigned long
 dmsg_crypto_id_callback(void)
@@ -81,14 +82,17 @@ dmsg_crypto_locking_callback(int mode, int type,
 		pthread_mutex_unlock(&crypto_locks[type]);
 	}
 }
+#endif
 
 void
 dmsg_crypto_setup(void)
 {
 	crypto_count = CRYPTO_num_locks();
 	crypto_locks = calloc(crypto_count, sizeof(crypto_locks[0]));
+#if 0
 	CRYPTO_set_id_callback(dmsg_crypto_id_callback);
 	CRYPTO_set_locking_callback(dmsg_crypto_locking_callback);
+#endif
 }
 
 static
@@ -114,13 +118,13 @@ dmsg_crypto_gcm_init(dmsg_ioq_t *ioq, char *key, int klen,
 		dmx_printf(6, "%02x", (unsigned char)iv_fixed[i]);
 	dmx_printf(6, "%s\n", " (fixed part only)");
 
-	EVP_CIPHER_CTX_init(&ioq->ctx);
+	ioq->ctx = EVP_CIPHER_CTX_new();
 
 	if (enc)
-		ok = EVP_EncryptInit_ex(&ioq->ctx, EVP_aes_256_gcm(), NULL,
+		ok = EVP_EncryptInit_ex(ioq->ctx, EVP_aes_256_gcm(), NULL,
 					(unsigned char*)key, NULL);
 	else
-		ok = EVP_DecryptInit_ex(&ioq->ctx, EVP_aes_256_gcm(), NULL,
+		ok = EVP_DecryptInit_ex(ioq->ctx, EVP_aes_256_gcm(), NULL,
 					(unsigned char*)key, NULL);
 	if (!ok)
 		goto fail;
@@ -143,7 +147,7 @@ dmsg_crypto_gcm_init(dmsg_ioq_t *ioq, char *key, int klen,
 	 * With a chunk size of 64 bytes, this adds up to 1 zettabyte of
 	 * traffic.
 	 */
-	ok = EVP_CIPHER_CTX_ctrl(&ioq->ctx, EVP_CTRL_GCM_SET_IVLEN,
+	ok = EVP_CIPHER_CTX_ctrl(ioq->ctx, EVP_CTRL_GCM_SET_IVLEN,
 				 DMSG_CRYPTO_GCM_IV_SIZE, NULL);
 	if (!ok)
 		goto fail;
@@ -159,7 +163,7 @@ dmsg_crypto_gcm_init(dmsg_ioq_t *ioq, char *key, int klen,
 	 * as GCM, will cause an error in _finish if the pt/ct size is not
 	 * a multiple of the cipher block size.
 	 */
-	EVP_CIPHER_CTX_set_padding(&ioq->ctx, 0);
+	EVP_CIPHER_CTX_set_padding(ioq->ctx, 0);
 
 	return 0;
 
@@ -203,24 +207,24 @@ dmsg_crypto_gcm_encrypt_chunk(dmsg_ioq_t *ioq, char *ct, char *pt,
 	*out_size = 0;
 
 	/* Re-initialize with new IV (but without redoing the key schedule) */
-	ok = EVP_EncryptInit_ex(&ioq->ctx, NULL, NULL, NULL,
+	ok = EVP_EncryptInit_ex(ioq->ctx, NULL, NULL, NULL,
 		(unsigned char*)ioq->iv);
 	if (!ok)
 		goto fail;
 
 	u_len = 0;	/* safety */
-	ok = EVP_EncryptUpdate(&ioq->ctx, (unsigned char*)ct, &u_len,
+	ok = EVP_EncryptUpdate(ioq->ctx, (unsigned char*)ct, &u_len,
 		(unsigned char*)pt, in_size);
 	if (!ok)
 		goto fail;
 
 	f_len = 0;	/* safety */
-	ok = EVP_EncryptFinal_ex(&ioq->ctx, (unsigned char*)ct + u_len, &f_len);
+	ok = EVP_EncryptFinal_ex(ioq->ctx, (unsigned char*)ct + u_len, &f_len);
 	if (!ok)
 		goto fail;
 
 	/* Retrieve auth tag */
-	ok = EVP_CIPHER_CTX_ctrl(&ioq->ctx, EVP_CTRL_GCM_GET_TAG,
+	ok = EVP_CIPHER_CTX_ctrl(ioq->ctx, EVP_CTRL_GCM_GET_TAG,
 				 DMSG_CRYPTO_GCM_TAG_SIZE,
 				 ct + u_len + f_len);
 	if (!ok)
@@ -233,14 +237,14 @@ dmsg_crypto_gcm_encrypt_chunk(dmsg_ioq_t *ioq, char *ct, char *pt,
 	}
 
 	*out_size = u_len + f_len + DMSG_CRYPTO_GCM_TAG_SIZE;
-	EVP_CIPHER_CTX_reset(&ioq->ctx);
+	EVP_CIPHER_CTX_reset(ioq->ctx);
 
 	return 0;
 
 fail:
 	ioq->error = DMSG_IOQ_ERROR_ALGO;
 fail_out:
-	EVP_CIPHER_CTX_reset(&ioq->ctx);
+	EVP_CIPHER_CTX_reset(ioq->ctx);
 	dm_printf(1, "%s\n", "error during encrypt_chunk");
 	return -1;
 }
@@ -256,14 +260,14 @@ dmsg_crypto_gcm_decrypt_chunk(dmsg_ioq_t *ioq, char *ct, char *pt,
 	*consume_size = 0;
 
 	/* Re-initialize with new IV (but without redoing the key schedule) */
-	ok = EVP_DecryptInit_ex(&ioq->ctx, NULL, NULL, NULL,
+	ok = EVP_DecryptInit_ex(ioq->ctx, NULL, NULL, NULL,
 		(unsigned char*)ioq->iv);
 	if (!ok) {
 		ioq->error = DMSG_IOQ_ERROR_ALGO;
 		goto fail_out;
 	}
 
-	ok = EVP_CIPHER_CTX_ctrl(&ioq->ctx, EVP_CTRL_GCM_SET_TAG,
+	ok = EVP_CIPHER_CTX_ctrl(ioq->ctx, EVP_CTRL_GCM_SET_TAG,
 				 DMSG_CRYPTO_GCM_TAG_SIZE,
 				 ct + out_size);
 	if (!ok) {
@@ -271,12 +275,12 @@ dmsg_crypto_gcm_decrypt_chunk(dmsg_ioq_t *ioq, char *ct, char *pt,
 		goto fail_out;
 	}
 
-	ok = EVP_DecryptUpdate(&ioq->ctx, (unsigned char*)pt, &u_len,
+	ok = EVP_DecryptUpdate(ioq->ctx, (unsigned char*)pt, &u_len,
 		(unsigned char*)ct, out_size);
 	if (!ok)
 		goto fail;
 
-	ok = EVP_DecryptFinal_ex(&ioq->ctx, (unsigned char*)pt + u_len, &f_len);
+	ok = EVP_DecryptFinal_ex(ioq->ctx, (unsigned char*)pt + u_len, &f_len);
 	if (!ok)
 		goto fail;
 
@@ -287,14 +291,14 @@ dmsg_crypto_gcm_decrypt_chunk(dmsg_ioq_t *ioq, char *ct, char *pt,
 	}
 
 	*consume_size = u_len + f_len + DMSG_CRYPTO_GCM_TAG_SIZE;
-	EVP_CIPHER_CTX_reset(&ioq->ctx);
+	EVP_CIPHER_CTX_reset(ioq->ctx);
 
 	return 0;
 
 fail:
 	ioq->error = DMSG_IOQ_ERROR_MACFAIL;
 fail_out:
-	EVP_CIPHER_CTX_reset(&ioq->ctx);
+	EVP_CIPHER_CTX_reset(ioq->ctx);
 	dm_printf(1, "%s\n",
 		  "error during decrypt_chunk "
 		  "(likely authentication error)");
diff --git a/lib/libdmsg/dmsg.h b/lib/libdmsg/dmsg.h
index cc73a44fa0..7234c5e892 100644
--- a/lib/libdmsg/dmsg.h
+++ b/lib/libdmsg/dmsg.h
@@ -251,7 +251,7 @@ struct dmsg_ioq {
 	int		error;
 	int		seq;			/* salt sequencer */
 	int		msgcount;
-	EVP_CIPHER_CTX	ctx;
+	EVP_CIPHER_CTX	*ctx;
 	char		iv[DMSG_MAX_IV_SIZE]; /* encrypt or decrypt iv[] */
 	dmsg_msg_t	*msg;
 	dmsg_msg_queue_t msgq;
diff --git a/lib/libfetch/Makefile b/lib/libfetch/Makefile
index c236aceffb..6cae1cef13 100644
--- a/lib/libfetch/Makefile
+++ b/lib/libfetch/Makefile
@@ -9,7 +9,7 @@ INCS=		fetch.h
 MAN=		fetch.3
 CLEANFILES=	ftperr.h httperr.h
 
-CFLAGS+=	-DWITH_SSL
+CFLAGS+=	-DWITH_SSL -DOPENSSL_SUPPRESS_DEPRECATED
 DPADD=		${LIBSSL} ${LIBCRYPTO}
 LDADD=		-lprivate_ssl -lprivate_crypto
 CFLAGS+=	${PRIVATELIB_CFLAGS}
diff --git a/lib/libldns/Makefile b/lib/libldns/Makefile
index 5668e210db..ac9566c58c 100644
--- a/lib/libldns/Makefile
+++ b/lib/libldns/Makefile
@@ -56,7 +56,8 @@ CFLAGS+= 	-I${.CURDIR} -I${LDNS}
 
 LDADD=		-lprivate_crypto
 DPADD=		${LIBCRYPTO}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 LDFLAGS+=       -rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
 
 WARNS?=		2
diff --git a/lib/libldns/ldns/config.h b/lib/libldns/ldns/config.h
index 0993c32416..cb4b5a3ec5 100644
--- a/lib/libldns/ldns/config.h
+++ b/lib/libldns/ldns/config.h
@@ -42,11 +42,11 @@
 
 /* Define to 1 if you have the declaration of `NID_ED25519', and to 0 if you
    don't. */
-#define HAVE_DECL_NID_ED25519 0
+#define HAVE_DECL_NID_ED25519 1
 
 /* Define to 1 if you have the declaration of `NID_ED448', and to 0 if you
    don't. */
-#define HAVE_DECL_NID_ED448 0
+#define HAVE_DECL_NID_ED448 1
 
 /* Define to 1 if you have the declaration of `NID_secp384r1', and to 0 if you
    don't. */
@@ -84,10 +84,10 @@
 /* #undef HAVE_ENGINE_LOAD_CRYPTODEV */
 
 /* Define to 1 if you have the `ERR_load_crypto_strings' function. */
-#define HAVE_ERR_LOAD_CRYPTO_STRINGS 1
+/* #undef HAVE_ERR_LOAD_CRYPTO_STRINGS */
 
 /* Define to 1 if you have the `EVP_dss1' function. */
-#define HAVE_EVP_DSS1 1
+/* #undef HAVE_EVP_DSS1 */
 
 /* Define to 1 if you have the `EVP_MD_CTX_new' function. */
 #define HAVE_EVP_MD_CTX_NEW 1
@@ -150,7 +150,7 @@
 /* #undef HAVE_LIBPCAP */
 
 /* Define if we have LibreSSL */
-#define HAVE_LIBRESSL 1
+/* #undef HAVE_LIBRESSL */
 
 /* Define to 1 if you have the `localtime_r' function. */
 #define HAVE_LOCALTIME_R 1
@@ -389,10 +389,10 @@
 #define USE_ECDSA 1
 
 /* Define this to enable ED25519 support. */
-/* #undef USE_ED25519 */
+#define USE_ED25519 1
 
 /* Define this to enable ED448 support. */
-/* #undef USE_ED448 */
+#define USE_ED448 1
 
 /* Define this to enable GOST support. */
 /* #undef USE_GOST */
diff --git a/lib/libssh/Makefile b/lib/libssh/Makefile
index 37e439d16d..e3f39145ea 100644
--- a/lib/libssh/Makefile
+++ b/lib/libssh/Makefile
@@ -51,8 +51,9 @@ MAN=	moduli.5
 WARNS?=	2
 NO_STRICT_ALIASING=
 
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	-I${.CURDIR} -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 CFLAGS+=	-I${.CURDIR}/../../contrib/ldns
 DPADD=		${LIBCRYPTO} ${LIBLDNS} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_crypto -lprivate_ldns -lutil -lz
